class PL_SHORTCUT
inherit TAG_SINGLETON
creation make
feature
    program : TWO_WAY_LINKED_LIST[ROW]
    make(p : TWO_WAY_LINKED_LIST[ROW]) is
    do
	program := p
    end

    row : ROW
    next_row : ROW

    pl_shortcut is
	--eliminate sequences like <B><1></1></B>
	--also handle multiple <EM>'s
    local
	i : INTEGER
	i0, i1 : INTEGER
	desired : CONTEXT
	done : BOOLEAN
	l0, l1 : LINKED_LIST[TAG_HOLDER]
	tag0, tag1 : TAG
	count : INTEGER

	must_have_color : TAG
	must_have_size : TAG
	saving, cost : INTEGER

	newl0, newl1 : LINKED_LIST[TAG_HOLDER]
	th0, th1 : TAG_HOLDER
	k : INTEGER
    do
	--should we recode to use this rule on the first pass?
	from  i := program.lower
	until i = program.upper
	    --don't check the last row because we need a next row
	    --for this optimization
	loop
	    --examine the cost of using PL tag to get to the desired context
	    row := program @ i
	    next_row := program @ (i + 1)

	    --first see what we can replace
	    --so look for matching close/open pairs at the end of l0 and
	    --at the start of l1

	    --there are further complications with size and colour
	    --we may have to use a particular size/color
	    must_have_color := Void
	    must_have_size := Void

	    saving := 0
	    cost := 9 --cost of <PL></PL>

	    done := false
	    l0 := row.tag_list
	    l1 := next_row.tag_list
	    i0 := l0.upper
	    i1 := l1.lower
	    count :=  0
	    from
	    until done
	    loop
		if i0 < l0.lower then
		    done := true
		elseif i1 > l1.upper then
		    done := true
		else
		    tag1 := l1.item(i1).tag
		    tag0 := l0.item(i0).tag
		    --if tag1.tag_start
		    if true
			and then tag1 = opposite_tag(tag0) then
			if tag0 = pl_tag then
			    --don't bother trying if
			    --<PL> already present
			    count := 0
			    done := true
			
    --we can't replace </size> ... <size> or </color> ... <color> in general
    --so we must stop when tag1 hits a <size> or <color>
			elseif is_start_color_tag(tag1) then
			    done := true
			elseif is_start_size_tag(tag1) then
			    done := true

			else
			    if is_start_color_tag(tag0) then
				must_have_color := tag0
				cost := cost + 7
			    elseif is_start_size_tag(tag0) then
				must_have_size := tag0
				cost := cost + 7
			    end
			    saving := saving + tag0.length + tag1.length
			    count := count + 1
			    i0 := i0 - 1
			    i1 := i1 + 1
			end
		    else
			done := true
		    end
		end
	    end

	    if saving > cost then
		--io.put_string("We have a winner!%N")
		--io.put_integer(count)
		--io.put_string(" ")
		--io.put_integer(saving)
		--io.put_string(" - ")
		--io.put_integer(cost)
		--io.put_new_line
		--row.show_info
		--next_row.show_info

		!!newl0.make
		!!newl1.make
		kludge(newl0, newl1, "PL")
		desired := row.context
		from k := 0
		until k = desired.u_count
		loop
		    cost := cost + 7
		    kludge(newl0, newl1, "U")
		    k := k + 1
		end
		if desired.b_flag then
		    cost := cost + 7
		    kludge(newl0, newl1, "B")
		end
		if desired.i_flag then
		    cost := cost + 7
		    kludge(newl0, newl1, "I")
		end
		if desired.s_flag then
		    cost := cost + 7
		    kludge(newl0, newl1, "S")
		end
		if desired.tt_flag then
		    cost := cost + 9
		    kludge(newl0, newl1, "TT")
		end
		if desired.em_flag then
		    cost := cost + 9
		    kludge(newl0, newl1, "EM")
		end
		if saving > cost then
		    if must_have_color /= Void then
			!!th0.make(row, must_have_color)
			!!th1.make(next_row, opposite_tag(must_have_color))
			th0.partner_with(th1)
			newl0.add_last(th0)
			newl1.add_first(th1)
		    end

		    if must_have_size /= Void then
			!!th0.make(row, must_have_size)
			!!th1.make(next_row, opposite_tag(must_have_size))
			th0.partner_with(th1)
			newl0.add_last(th0)
			newl1.add_first(th1)
		    end

		    from k := 1
		    until k > count
		    loop
			l0.remove_last
			l1.remove_first
			k := k + 1
		    end
		    l0.append_collection(newl0)
		    newl1.append_collection(l1)
		    next_row.put_tag_list(newl1)
		end
	    end

	    i := i + 1
	end
    end

    kludge(newl0, newl1 : LINKED_LIST[TAG_HOLDER]; s : STRING) is
    local
	th0, th1 : TAG_HOLDER
    do
	!!th0.make(row, tag_table.at(s))
	!!th1.make(next_row, tag_table.at("/" + s))
	th0.partner_with(th1)
	newl0.add_last(th0)
	newl1.add_first(th1)
    end
    
    --not nice...need to think of cleaner way of doing these two functions
    is_start_color_tag(t : TAG) : BOOLEAN is
    local
	test : COLOR_TAG
    do
	if t.tag_start then
	    test ?= t
	    if test /= Void then
		Result := True
	    end
	end
    end

    is_start_size_tag(t : TAG) : BOOLEAN is
    local
	test : SIZE_TAG
    do
	if t.tag_start then
	    test ?= t
	    if test /= Void then
		Result := True
	    end
	end
    end
end
