class REMOVE_TAGS
inherit TAG_SINGLETON
creation make
feature
    program : TWO_WAY_LINKED_LIST[ROW]
    make(p : TWO_WAY_LINKED_LIST[ROW]) is
    do
	program := p
    end

    last_row : ROW
	--holds last nonempty row or Void

    remove_tags is
	--eliminate sequences like <B><1></1></B>
	--also handle multiple <EM>'s
    local
	i : INTEGER
	row : ROW
    do
	--can we use this rule on the first pass?

	--a little messy because we get rid of rows with
	--empty tag_lists at the same time
	last_row := Void
	from  i := program.lower
	until i > program.upper
	loop
	    row := program @ i
	    if clean_tag_list(row) then
		program.remove(i)
	    else
		i := i + 1
	    end
	end
    end
    
    --not nice...need to think of cleaner way of doing these two functions
    is_start_color_tag(t : TAG) : BOOLEAN is
    local
	test : COLOR_TAG
    do
	if t.tag_start then
	    test ?= t
	    if test /= Void then
		Result := True
	    end
	end
    end

    is_start_size_tag(t : TAG) : BOOLEAN is
    local
	test : SIZE_TAG
    do
	if t.tag_start then
	    test ?= t
	    if test /= Void then
		Result := True
	    end
	end
    end

    clean_tag_list(row : ROW) : BOOLEAN is
	--return true if tag_list ends up empty
	--get rid of <B></B> et. al
	--get rid of <EM><EM>
	--do <6><7> ... </7></6> --> <7>...</7>
	--do <r><g> ... </g></r> --> <g>...</g>
	--do <B><PL> ... </PL></B> --> <PL>...</PL>
	--do <EM><S> ... </S></EM> --> <S>...</S>
    local
	it : ITERATOR[TAG_HOLDER]
	t, p : TAG_HOLDER
	tag : TAG
	newl : LINKED_LIST[TAG_HOLDER]
	last_em : TAG_HOLDER
	last_color : TAG_HOLDER
	last_size : TAG_HOLDER

	other_tags : LINKED_LIST[TAG_HOLDER]
	ems_tags : LINKED_LIST[TAG_HOLDER]
    do
	!!other_tags.make
	!!ems_tags.make

	it := row.tag_list.get_new_iterator
	from  it.start
	until it.is_off
	loop
	    t := it.item
	    p := t.partner
	    tag := t.tag
	    --eliminate same row open/close pairs
	    --if row /= t.row then
		--io.put_string("BUG!%N")
	    --end

	    if p.row = row then
		t.set_redundant
		p.set_redundant
	    else

		--eliminate COLOR_TAG and SIZE_TAG shadows
		if is_start_color_tag(tag) then
		    if last_color /= Void then
			check_shadow(last_color, t)
		    end
		    last_color := t
		elseif is_start_size_tag(tag) then
		    if last_size /= Void then
			check_shadow(last_size, t)
		    end
		    last_size := t
		else
		    other_tags.add_last(t)
		    if tag = em_tag then
    --can eliminate same row <EM>'s as long as there aren't <PL>'s
    --see PL section
    --(they have to end on the same row too!)
			if last_em /= Void then
			    --if last_em.redundant then
				--io.put_string("trouble brewing...%N")
			    --end
			    if last_em.partner.row = p.row then
				last_em.set_redundant
				last_em.partner.set_redundant
				t.set_redundant
				p.set_redundant
				last_em := Void
			    else
				last_em := t
			    end
			else
			    last_em := t
			end
			ems_tags.add_last(t)
		    elseif tag = s_tag then
			--PL and S have the power to turn EM off;
			--EM is ignored after S, but not after PL
			ems_tags.add_last(t)
			--trim(ems_tags)
			ems_tags.clear
		    elseif tag = pl_tag then
			last_em := Void
			--trim(other_tags)
			other_tags.clear
		    end
		end

	    end
	    it.next
	end

	--by now, in a row,
	--there are no end tags after a start tag (since tags must be nested)
	--for each category except U there is at most one tag
	--(categories are colour, size, B, I, U, EM, S, TT)
	--an EM tag never follows a S tag

	!!newl.make
	it := row.tag_list.get_new_iterator
	from  it.start
	until it.is_off
	loop
	    t := it.item
	    if not t.redundant then
		newl.add_last(t)
	    end
	    it.next
	end

	remove_palindrome(newl)
	row.put_tag_list(newl)

	!!newl.make
	it := row.tag_list.get_new_iterator
	from  it.start
	until it.is_off
	loop
	    t := it.item
	    if not t.redundant then
		newl.add_last(t)
	    end
	    it.next
	end
	if newl.is_empty and then last_row /= Void then
	    last_row.text.append(row.text)
	    Result := true
	else
	    last_row := row
	    row.put_tag_list(newl)
	end
    end

    check_shadow(t1, t2 : TAG_HOLDER) is
	-- if t1 is shadowed by t2 mark it redundant
    local
	t1p : TAG_HOLDER
    do
	t1p := t1.partner
	if t1p.row = t2.partner.row then
	    t1.set_redundant
	    t1p.set_redundant
	end
    end

    trim(list : LINKED_LIST[TAG_HOLDER]) is
	--if any other elements are shadowed by the last element
	--then mark them redundant
	--XXX: more efficient if we traverse backwards and break
    local
	it : ITERATOR[TAG_HOLDER]
	lastprow : ROW
	t, p : TAG_HOLDER
    do
	if not list.is_empty then
	    lastprow := list.last.partner.row
	    list.remove_last
	    it := list.get_new_iterator
	    from it.start
	    until it.is_off
	    loop
		t := it.item
		p := t.partner
	  	if p.row = lastprow then
		    t.set_redundant
		    p.set_redundant
		end
		it.next
	    end
	end
    end

    remove_palindrome(tag_list : LINKED_LIST[TAG_HOLDER]) is
	--get rid of </I></B><B><I> etc.
    local
	i, j : INTEGER
	t, t2 : TAG_HOLDER
	done : BOOLEAN
	it : ITERATOR[TAG_HOLDER]
    do
	--find first starting tag
	from i := tag_list.lower
	until done or else i > tag_list.upper
	loop
	    t := tag_list @ i
	    if t.tag.tag_start then
		done := True
	    else
		i := i + 1
	    end
	end

	--start removing </tag><tag> pairs from the inside out
	if done then
	    done := false
	    j := i - 1
	    from
	    until done
	    loop
		if j < tag_list.lower then
		    done := true
		elseif i > tag_list.upper then
		    done := true
		else
		    t := tag_list @ i
		    t2 := tag_list @ j
		    if t2.tag = opposite_tag(t.tag) then
			t2.partner_with(t.partner)
			t.set_redundant
			t2.set_redundant
			i := i + 1
			j := j - 1
		    else
			done := true
		    end
		end
	    end
	end

    end
end
